program muehle(input,output);   (*$c-*)

(*      Verwendet Shannon  A - Strategie und den
        Alpha - Betta - Algorithmus                             *)

const  zeigen = true;
       maxsp  =  6;          (* maximale Spielstaerke *)

type   tstein = (leer,spieler,rechner);
       tmodus = (setzen,ziehen,springen);
       tstr   = string[30];
       tzug   = array[0..3] of integer;
       tstat  = array[spieler..rechner] of record
                  modus   : tmodus;
                  steine,
                  zaehler : integer;
                end;

        tbrett = record
                   anzahl : 0..1;
                   k,l    : integer;
                   brett  : array[0..23] of tstein;
                   status : tstat;
                   case integer of
                     0 : (zug : tzug);
                     1 : (von,
                          zu,
                          schl_nr : integer;
                          muehle : boolean)
                  end;

const steine : array[leer..rechner] of string[5] = (' ','X','O');
      geg    : array[spieler..rechner] of tstein=(rechner,spieler);

(* Tabelle mit den Nachtbarpositionen, mit denen
   eine Muehle geschlossen werden kann  *)

muehlen_nachb : array[0..23,0..3] of byte =
     (( 1, 2, 9,21),( 0, 2, 4, 7),( 0, 1,14,23),( 4, 5,10,18),
      ( 3, 5, 1, 7),( 3, 4,13,20),( 7, 8,11,15),( 6, 8, 1, 4),
      ( 6, 7,12,17),(10,11, 0,21),( 9,11, 3,18),( 9,10, 6,15),
      (13,14, 8,17),( 5,20,12,14),( 2,23,12,13),( 6,11,16,17),
      (15,17,19,22),(15,16, 8,12),(19,20, 3,10),(18,20,16,22),
      (18,19, 5,13),(22,23, 0, 9),(21,23,16,19),(21,22, 2,14));

(* Tabelle mit den max. vier moeglichen Nachtbarpositionen
   eines Steines. 30 gibt eine nicht vorh. Position an *)

nachbar : array[0..23,0..3] of byte =
     (( 1, 9,30,30),( 2, 4, 0,30),(30,14, 1,30),( 4,10,30,30),
      ( 5, 7, 3, 1),(30,13, 4,30),( 7,11,30,30),( 8,30, 6, 4),
      (30,12, 7,30),(10,21,30, 0),(11,18, 9, 3),(30,15,10, 6),
      (13,17,30, 8),(14,20,12, 5),(30,23,13, 2),(16,30,30,11),
      (17,19,15,30),(30,30,16,12),(19,30,30,10),(20,22,18,16),
      (30,30,19,13),(22,30,30, 9),(23,30,21,19),(30,30,22,14));

(* Tabelle mit den 16 moeglichen Muehlen *)

muehlen : array[0..15,0..2] of byte =
      (( 0, 1, 2),( 3, 4, 5),( 6, 7, 8),( 9,10,11),(12,13,14),
       (15,16,17),(18,19,20),(21,22,23),( 0, 9,21),( 3,10,18),
       ( 6,11,15),( 1, 4, 7),(16,19,22),( 8,12,17),( 5,13,20),( 2,14,23));

(* Liste mit den Feldbezeichnungen der Positionen auf dem Spielbrett *)

posit : array[0..23] of string[2] =
       ('A1','D1','G1','B2','D2','F2','C3','D3',
        'E3','A4','B4','C4','E4','F4','G4','C5',
        'D5','E5','B6','D6','F6','A7','D7','G7');

var  feld          : tbrett;           (* Spielbrett *)
     modus_alt     : tmodus;
     spiel_ist_aus : boolean;
     spielstaerke  : integer;
     muehlen_menge : array[0..15] of set of 0..23;
     minmax        : array[1..maxsp] of integer;
     bestzug       : tzug;
     ant           : char;

type listeninhalt  =  record
                        value  :  integer;
                        zug    :  tzug;
                      end;

function kleiner(x,y : listeninhalt) : boolean;
  begin kleiner:=x.value>y.value end;             (* Absteigende Liste *)

{$i muehle.bes}

procedure graein;                  begin writeln(chr(27),chr(27),'G ');end;
procedure posgo(p1, p2 : integer); begin writeln('M ',p1,' ',p2); end;

{$i autor.inc}

procedure anfang;
  begin         (*  Anfangsbild erstellen *)
    graein;
    writeln('Z ');
    writeln('Y 0');
    writeln('P 0');
    posgo(115,219); writeln('R 185 35');
    posgo(114,218); writeln('R 187 37');
    posgo(20,227);  writeln('G3 34'); writeln('B CHIP ');
    posgo(40,219);  writeln('G3 17'); writeln('B special');
    posgo(150,219); writeln('G3 52'); writeln('B Muhle');
    posgo(188,246); writeln('R 2 2');
    posgo(193,246); writeln('R 2 2');
    posgo(116,219); writeln('D 116 253');
    posgo(299,219); writeln('D 299 253');
    writeln('A');
  end;

{$i beschr.inc}


{$i liste.bib   }
{$i muehle01.inc}
{$i muehle02.inc}
{$i muehle03.inc}
{$i muehle04.inc}

begin   (*  M U E H L E  *)
  initvars;
  randomize;
  anfang;
  autor(400,200);
  repeat
    gotoxy(15,8); write('Benoetigen Sie die Spielregeln  J/N '); clreol;
    gotoxy(50,8);
    read(kbd,ant);
  until ant in ['J','j','N','n'];
  if ant in ['J','j'] then begin
                             graein;
                             stein_eintragen(250,120,spieler);
                             stein_eintragen(250,141,rechner);
                             write('A');
                             beschreibung(1);
                             anfang;
                             beschreibung(20);
                           end;
  repeat
    anfang;
    initial;
    if antwort_ja('Wollen Sie anfangen')  then
         begin
           spielerzug;
           if not spiel_ist_aus then begin
                                       repeat  feld.zug[1]:=random(24);
                                       until   feld.brett[feld.zug[1]]=leer;
                                       posgo(122,20);
                                       writeln('B ',posit[feld.zug[1]]);
                                       mache_zug(rechner,zeigen);
                                     end;
         end
       else
         begin
           feld.zug[1]:=random(24);
           posgo(122,20);
           writeln('B ',posit[feld.zug[1]]);
           mache_zug(rechner,zeigen);
         end;
    while not spiel_ist_aus do begin
                                 spielerzug;
                                 if not spiel_ist_aus then rechnerzug;
                               end;
  until not antwort_ja('Noch ein Spiel');
  write('A');
  clrscr;
end.



